﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;

public partial class ToolTip_DynamicControls : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void grdOwnerHistory_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            if (!Object.Equals(this.RadToolTipManager1, null))
            {
                //create a control dynamically, add it to the cell, add it to the tooltipmanager
                Label DynamicControl = new Label();
                DynamicControl.Text = DateTime.Now.ToString();
                dataItem["SecondColumn"].Controls.Add(DynamicControl);
                RadToolTipManager1.TargetControls.Add(DynamicControl.ClientID, "example value", true);

                //for comparison - add a static control to the tooltip manager
                //More checks need to be done in order to avoid exceptions, but the method is available in the online demos: http://demos.telerik.com/aspnet-ajax/tooltip/examples/targetcontrolsandajax/defaultcs.aspx
                 Control target = e.Item.FindControl("Label1");
                 RadToolTipManager1.TargetControls.Add(target.ClientID, "other value", true);
            }
        }
    }

    protected void NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = GetData();
    }

    protected DataTable GetData()
    {
        //just a dummy datasource for the sake of test
        DataTable tbl = new DataTable();
        tbl.Columns.Add(new DataColumn("FirstColumn"));
        tbl.Columns.Add(new DataColumn("SecondColumn"));
        tbl.Columns.Add(new DataColumn("ThirdColumn"));
        tbl.Columns.Add(new DataColumn("FourthColumn"));
        tbl.Rows.Add(new object[] { "firstRecord1", "firstRecord2", "firstRecord3", "firstRecord4" });
        tbl.Rows.Add(new object[] { "secondRecord1", "secondRecord2", "secondRecord3", "secondRecord4" });
        tbl.Rows.Add(new object[] { "thirdRecord1", "thirdRecord2", "thirdRecord3", "thirdRecord4" });
        tbl.Rows.Add(new object[] { "fourthRecord1", "fourthRecord2", "fourthRecord3", "fourthRecord4" });
        return tbl;
    }

    protected void OnAjaxUpdate(object sender, ToolTipUpdateEventArgs args)
    {
        //just a single control added, generally this should be an entire user control, or something sensible at all ;)
        Label ctrl = new Label();
        ctrl.Text = DateTime.Now.ToString();
        args.UpdatePanel.ContentTemplateContainer.Controls.Add(ctrl);
    }

}